/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	NavigateScreenAction
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.File;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.xml.parsers.DocumentBuilderFactory;

import jp.co.ntt.lms.lo.scorm.util.CachedNode;
import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.lo.scorm.util.XMLUtil;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsScreenAction;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

/**
 *	NavigateScreenAction クラス<br>
 *	navigationコマンドの画面生成クラス<br>
 */
public class NavigateScreenAction extends XmsScreenAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public NavigateScreenAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {}

	/**
	 * navigation要求受付処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		try {
			HttpServletRequest request = xmsRequest.getRequest();
			HttpSession session = request.getSession();
			ServletContext application = session.getServletContext();

			// BusinessBeanを取得する
			NavigateBusinessBean navigateBusinessBean = (NavigateBusinessBean)xmsResponse.getBusinessBean();

			// 起動パラメータを取得する
			ExecuteParameters executeParameters = navigateBusinessBean.getExecuteParameters();

			String xmlFilename;

			// DOM Documentをキャッシュから取得する
			CachedNode framesetDefine =
				(CachedNode)ContentsInfoCacher.get("FramesetDefine", executeParameters.getManifestID());

			// キャッシュにDOM Documentが存在しない場合
			if (framesetDefine == null) {
				// カスタマイズされたフレームセットxmlへのフルパスを作成する
				StringBuffer customFramesetURL = new StringBuffer();

				customFramesetURL.append(SG.get("ContentsBaseURL"));
				customFramesetURL.append(executeParameters.getManifestID());
				customFramesetURL.append(File.separator);
				customFramesetURL.append("_customize");
				customFramesetURL.append(File.separator);
				customFramesetURL.append("Frameset.xml");

				xmlFilename = customFramesetURL.toString();

				// カスタマイズされたフレームセットxmlが存在する場合
				if (new File(xmlFilename).exists()) {
					// フレームセットxmlをDOM Documentにparseする
					framesetDefine =
						new CachedNode(XMLUtil.newDocumentBuilder(false).parse(xmlFilename).getDocumentElement());
				}

				// カスタマイズされたフレームセットxmlが存在しない場合
				if (framesetDefine == null) {
					StringBuffer defaultFramesetURL = new StringBuffer();

					defaultFramesetURL.append(SG.get("ContentsBaseURL"));
					defaultFramesetURL.append("_default");
					defaultFramesetURL.append(File.separator);
					defaultFramesetURL.append("DefaultFrameset.xml");

					xmlFilename = defaultFramesetURL.toString();

					synchronized (ContentsInfoCacher.class) {
						// キャッシュからデフォルトのボタン出力xslを取得する
						framesetDefine = (CachedNode)ContentsInfoCacher.get("FramesetDefine", "");

						// 取得できなかった場合はデフォルトのフレームセットxmlを読み込み、DOM Documentを作成する
						if (framesetDefine == null) {
							// DOM Documentを作成する
							framesetDefine =
								new CachedNode(
									DocumentBuilderFactory
										.newInstance()
										.newDocumentBuilder()
										.parse(xmlFilename)
										.getDocumentElement());

							// キャッシュにDOM Documentを設定する
							ContentsInfoCacher.set(
								"FramesetDefine",
								"",
								framesetDefine,
								new ContentsInfoCacher.FileValidateChecker(xmlFilename));
						}
					}
				}

				// キャッシュにDOM Documentを設定する
				ContentsInfoCacher.set(
					"FramesetDefine",
					executeParameters.getManifestID(),
					framesetDefine,
					new ContentsInfoCacher.FileValidateChecker(xmlFilename));
			}

			NavigateScreenBean navigateScreenBean = new NavigateScreenBean();

			navigateScreenBean.setFramesetDefine(framesetDefine);

			xmsResponse.setScreenBean(navigateScreenBean);
		}
		catch (Exception ex) {
			throw new XmsSystemException(ex);
		}
	}
}
